.include "m16def.inc"
.include "macros.inc"

.def FAmax=r1	;     FA
.def FBmax=r2	;     FB
.def FCmax=r3  ;     FC

.def rFA=r4	;   
.def rFB=r5	;   
.def rFC=r6	;   

.def sFA=r7	;    
.def sFB=r8	;    
.def sFC=r9	;    

.def D=r10	;
.def ocr_0=r11	;   TCNT0  0

.def M=r12	;  ( 4  6 -     )
	;    .
.def FA_0=r13	;    
.def FB_0=r14	;    
.def FC_0=r15	;    

.def temp1=r17	; 

.equ A=4	;   
.equ B=5	;   
.equ C=6	;   

/*
.equ S1=0	;  S1
.equ S2=1	;  S2
.equ S3=2	;  S3
.equ S4=3	;  S4
.equ S5=4	;  S5
.equ S6=6	;  S6	*/



.equ const=8
;Macros==================================================================================
;    .....................................................
.macro brinv
	ldi r16,1<<@1	;@0-    
	eor @0,r16	;@1-   , 
.endm
;     (  1,   =1;     , ,   =0)
.macro out_B	;     4,5,6   4,5,6    
	mov r16,M	;  r16   
	andi r16,1<<4|1<<5|1<<6
	in r17,PORTB
	andi r17,~(1<<4|1<<5|1<<6)
	or r17,r16
	out portb,r17
.endmacro




;RAM====================================================================================
		.DSEG


;Flush==================================================================================
		.CSEG
		.org $000
		rjmp reset
		.org $012
		rjmp T0_OVF
		.org $01C
		rjmp ADC_com


FA:	.db 0,127,220,255,220,127
FB:	.db 220,127,0,127,220,255
FC:	.db 220,255,220,127,0,127

; ............................................................
reset:
	Ram_00
	SPini
;0..............................................................................
	ldi r16,1<<CS02
	out TCCR0,r16 ;  - 256

	ldi r16,1<<TOIE0
	out TIMSK,r16 ;   
;1...............................................................................
; 8- .   .   (  -   .)
	ldi r16,1<<WGM10|1<<COM1A1|1<<COM1B1
	out TCCR1A,r16
	ldi r16,1<<CS10|1<<WGM12
	out TCCR1B,r16
;2...............................................................................
; ,   .  
	ldi r16,1<<WGM20|1<<WGM21|1<<COM21|1<<CS20
	out TCCR2,r16
; ..................................................................
	;PORTB
	ser r16
	out DDRB,r16	;1,2,3,PB4,PB5,PB6 -  
	;PORTC
	ldi r16,0
	out DDRC,r16	; 
	clr r16
	out PORTC,r16	;  

	;PORTD
	ldi r16, 1<<4|1<<5|1<<7
	out ddrd,r16

; .............................................................................
; ,    ,  2
	ldi r16,1<<ADEN|1<<ADIE|1<<ADPS0
	out ADCSR,r16
;  AVCC,  , ADC0
	ldi r16,1<<REFS0|1<<ADLAR
	out ADMUX,r16
;............................................................................................


	adrZ FA	;      Z
	mov rFA,ZL	; 
	mov sFA,ZL	; 
	mov FA_0,sFA	;    
	subi zl,(-6)
	mov FAmax,zl	;    FAmax

	adrZ FB
	mov rFB,zl
	mov sFB,zl
	mov FB_0,sFB
	inc FB_0
	inc FB_0
	subi zl,(-6)	;  
	mov FBmax,zl

	adrZ FC
	mov rFC,zl
	mov sFC,zl
	mov FC_0,sFC
	ldi r16,4
	add FC_0,r16
	subi zl,(-6)	;  
	mov FCmax,zl

	sei

main:



rjmp main

;function________________________________________________________________________________
;  .............................................................
onA:
	in r16,TCCR1A
	sbr r16,1<<com1A1
	out TCCR1A,r16

	ret
;  ...........................................................
offA:
	in r16,tccr1A
	cbr r16,1<<com1A1
	out tccr1A,r16
	ret
;...................................................

;Interrupt________________________________________________________________________________
T0_OVF:  ;   TCNT0=248 (f=60   30    )
	out TCNT0,ocr_0 ;        
	push r16
	in r16,sreg
	push r16
;.....................................................................................
		; 
	ldi r16,255
	sub r16,ocr_0	;  
	division_IB r16,const,D;   
	mov r16,D 	;  r16
	cpi r16,0
	brne PC+2	; =0,   =1
	inc D	
;.....................................................................................
	mov zl,rFA	;   
	cp zl,FAmax
	brcs L0
	adrZ FA
L0:	
	mov temp1,ZL	;C    
	lpm r0,Z+
	  division_RB r0,D,r0;  
	; ZL=FA  
	cp temp1,FA_0	; ZL=sFA
	brne M1
	  brinv M,A;  
M1:	out_B
	
	out ocr1AL,r0
	mov rFA,ZL
;.......................................................................................
	mov zl,rFB	;   
	cp zl,FBmax
	brcs L1
	adrZ FB
L1:
	mov temp1,ZL
	lpm r0,Z+
	  division_RB r0,D,r0;  
	; ZL=FB_0     
	cp temp1,FB_0
	brne M2
	  brinv M,B
M2:	out_B
	out ocr1BL,r0
	mov rFB,ZL
;.......................................................................................
	mov zl,rFC	;   
	cp zl,FCmax
	brcs L2
	adrZ FC
L2:
	mov temp1,ZL
	lpm r0,Z+
	  division_RB r0,D,R0
	; ZL=FC_0   
	cp temp1,FC_0
	brne M3
	  brinv M,C
M3:	out_B
	out ocr2,r0
	mov rFC,ZL


;........................................................................................	
	sbi ADCSR,ADSC
;....................................................................................
	pop r16
	out sreg,r16
	pop r16
reti
; _____________...........................................................................
ADC_com:
	push r16
	in r16,sreg
	push r16
	in r16,ADCH
	cpi r16,241
	brcs PC+2
	ldi r16,240
	mov ocr_0,r16
	pop r16
	out sreg,r16
	pop r16

reti

